 ; DblClk By Dean Harding (2005).
 ; http://www.codeka.com/blogs/index.php?cat=21
 ; Translated into MASM32 by Andrew Robinson (2006).

 ; To quit, simply run the program again and it will unload any resident program.

 .386
 .model flat, stdcall
 option casemap :none   ; case sensitive

 include \dev\masm32\include\windows.inc
 include \dev\masm32\include\user32.inc
 include \dev\masm32\include\kernel32.inc
 includelib \dev\masm32\lib\user32.lib
 includelib \dev\masm32\lib\kernel32.lib

 MOUSEINPUT STRUCT
    x           DWORD     ?
    y           DWORD     ?
    mouseData   DWORD     ?
    dwFlags     DWORD     ?
    time        DWORD     ?
    dwExtraInfo DWORD     ?
 MOUSEINPUT ENDS

 KEYBDINPUT STRUCT
    wVk         WORD      ?
    wScan       WORD      ?
    dwFlags     DWORD     ?
    time        DWORD     ?
    dwExtraInfo DWORD     ?
 KEYBDINPUT ENDS

 HARDWAREINPUT STRUCT
    uMsg        DWORD     ?
    wParamL     WORD      ?
    wParamH     WORD      ?
 HARDWAREINPUT ENDS

 INPUT STRUCT
    dtype       DWORD     ?
    UNION
      mi        MOUSEINPUT    <>
      ki        KEYBDINPUT    <>
      hi        HARDWAREINPUT <>
    ENDS
 INPUT ENDS

 MSLLHOOKSTRUCT STRUCT
    pt          POINT      <>
    mouseData   DWORD      ?
    flags       DWORD      ?
    time        DWORD      ?
    dwExtraInfo DWORD      ?
 MSLLHOOKSTRUCT ENDS


 m2m MACRO M1, M2
   push M2
   pop  M1
 ENDM

 ArrayOffset MACRO index, offset
   mov eax, sizeof INPUT
   mul index	; edx is wiped *
   mov offset, OFFSET inputs
   add offset, eax
 ENDM

 StartHook PROTO :DWORD
 HookProc  PROTO :DWORD,:DWORD,:DWORD

.data		; Global initialised
  hHook       dd 0
  hEvent      dd 0
  EventName   db "dblclick", 0
  szMsg1      db "Error creating event.",0
  ;szMsg2      db "Program already running.",0
  szBye       db "Bye!",0     

.data?		; Global uninitialised
  inputs INPUT 3 dup (<>)

.code

start:
 
  invoke GetModuleHandle, NULL
  invoke StartHook, eax
  invoke ExitProcess, eax	; eax set from StartHook

; #########################################################################


ClearMem proc dest:DWORD, len:DWORD
  push edi
  mov edi, dest
  mov ecx, len
  xor eax, eax
  cld
  mov edx, ecx
  and edx, 3	; mod 4
  shr ecx, 2	; idiv 4
  rep stosd
  or ecx, edx
  jz @F
  rep stosb	; leftover
  @@:
  pop edi
  ret
ClearMem endp 


StartHook proc hinst:DWORD
    LOCAL Msg:MSG
    
    invoke CreateEvent, 0, TRUE, FALSE, ADDR EventName
    mov hEvent, eax
    
    .If hEvent == NULL
        invoke MessageBox, 0, ADDR szMsg1, ADDR EventName, MB_ICONEXCLAMATION or MB_SYSTEMMODAL
        ret
    .Endif

    CALL GetLastError
    .If hEvent != NULL && eax == ERROR_ALREADY_EXISTS
        ;invoke MessageBox, 0, ADDR szMsg2, ADDR EventName, MB_ICONEXCLAMATION or MB_SYSTEMMODAL
        CALL StopHook	; just exit on second call (saves mucking with cmdline options)
        ret      
    .Endif

    .If hHook == 0
        invoke SetWindowsHookEx, WH_MOUSE_LL, ADDR HookProc, hinst, 0
        mov hHook, eax
    .Endif

    StartLoop:
      invoke GetMessage, ADDR Msg, NULL, 0, 0     ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR Msg           ; translate it
      invoke DispatchMessage,  ADDR Msg           ; send it to message proc
      
      ;invoke WaitForSingleObject, hEvent, 0      ; (not needed)
      ;.If (Msg.message == WM_QUIT) || (eax == WAIT_OBJECT_0)
      ;   jmp ExitLoop
      ;.Endif 
    jmp StartLoop
    ExitLoop:
    
    .If hHook
       invoke UnhookWindowsHookEx, hHook
    .Endif
    invoke CloseHandle, hEvent
    invoke MessageBox, 0, ADDR szBye, ADDR EventName, MB_SYSTEMMODAL
    
    mov eax, Msg.wParam
    ret
StartHook endp


HookProc proc nCode:DWORD, wParam:DWORD, lParam:DWORD
  push esi	; Msg ptr
  push edi	; array index

  ; To enable the system to process the message, the return value must be zero.
  ; To discard the message, the return value must be a nonzero value. 

  invoke WaitForSingleObject, hEvent, 0   
  .If eax == WAIT_OBJECT_0
     invoke PostQuitMessage, 0
     xor eax, eax
     jmp exit
  .Endif

  ; If nCode is less than zero, the hook procedure must pass the message to CallNextHookEx
  ; without further processing and should return the value returned by CallNextHookEx.

  cmp nCode, 0
  jnl @F	; signed
  invoke CallNextHookEx, 0, nCode, wParam, lParam	; eax set
  jmp exit

  @@:
  mov eax, [wParam]

  .If eax == WM_MBUTTONDOWN
      ; simulate a left-button down, left-button up, left-button down combo     
      invoke ClearMem, ADDR inputs, sizeof(INPUT) * 3

      mov esi, lParam
      assume esi: PTR MSLLHOOKSTRUCT
      mov ecx, OFFSET inputs		; first element
      mov (INPUT PTR [ecx]).dtype, INPUT_MOUSE
      m2m (INPUT PTR [ecx]).mi.x, [esi].pt.x
      m2m (INPUT PTR [ecx]).mi.y, [esi].pt.y
      mov (INPUT PTR [ecx]).mi.dwFlags, MOUSEEVENTF_LEFTDOWN
      m2m (INPUT PTR [ecx]).mi.time, [esi].time
      
      mov edi, 1
      ArrayOffset edi, ecx
      mov (INPUT PTR [ecx]).dtype, INPUT_MOUSE
      m2m (INPUT PTR [ecx]).mi.x, [esi].pt.x
      m2m (INPUT PTR [ecx]).mi.y, [esi].pt.y
      mov (INPUT PTR [ecx]).mi.dwFlags, MOUSEEVENTF_LEFTUP
      m2m (INPUT PTR [ecx]).mi.time, [esi].time
      
      mov edi, 2
      ArrayOffset edi, ecx
      mov (INPUT PTR [ecx]).dtype, INPUT_MOUSE
      m2m (INPUT PTR [ecx]).mi.x, [esi].pt.x
      m2m (INPUT PTR [ecx]).mi.y, [esi].pt.y
      mov (INPUT PTR [ecx]).mi.dwFlags, MOUSEEVENTF_LEFTDOWN
      m2m (INPUT PTR [ecx]).mi.time, [esi].time
      assume esi: nothing

      invoke SendInput, 3, ADDR inputs, sizeof INPUT
      mov eax, 1
      jmp exit

  .Elseif eax == WM_MBUTTONUP
      ; simulate the final left-button up
      invoke ClearMem, ADDR inputs, sizeof INPUT

      mov esi, lParam
      assume esi: PTR MSLLHOOKSTRUCT
      mov ecx, OFFSET inputs
      mov (INPUT PTR [ecx]).dtype, INPUT_MOUSE
      m2m (INPUT PTR [ecx]).mi.x, [esi].pt.x
      m2m (INPUT PTR [ecx]).mi.y, [esi].pt.y
      mov (INPUT PTR [ecx]).mi.dwFlags, MOUSEEVENTF_LEFTUP
      m2m (INPUT PTR [ecx]).mi.time, [esi].time
      assume esi: nothing

      invoke SendInput, 1, ADDR inputs, sizeof INPUT
      mov eax, 1
      jmp exit         
  .Endif

  xor eax, eax   ; default processing

  exit:
  pop edi
  pop esi
  ret      
HookProc endp


StopHook proc
  invoke OpenEvent, EVENT_MODIFY_STATE, FALSE, ADDR EventName
  mov hEvent, eax
  .If hEvent
     invoke SetEvent, hEvent
  .Endif
  ret    
StopHook endp


end start
